# StochasticDiffEqHighOrder.jl

[![Join the chat at https://julialang.zulipchat.com #sciml-bridged](https://img.shields.io/static/v1?label=Zulip&message=chat&color=9558b2&labelColor=389826)](https://julialang.zulipchat.com/#narrow/stream/279055-sciml-bridged)
[![Global Docs](https://img.shields.io/badge/docs-SciML-blue.svg)](https://docs.sciml.ai/DiffEqDocs/stable/solvers/sde_solve/)

[![ColPrac: Contributor's Guide on Collaborative Practices for Community Packages](https://img.shields.io/badge/ColPrac-Contributor%27s%20Guide-blueviolet)](https://github.com/SciML/ColPrac)
[![SciML Code Style](https://img.shields.io/static/v1?label=code%20style&message=SciML&color=9558b2&labelColor=389826)](https://github.com/SciML/SciMLStyle)

StochasticDiffEqHighOrder.jl is a component of the [OrdinaryDiffEq.jl](https://github.com/SciML/OrdinaryDiffEq.jl) monorepo providing high-order adaptive stochastic Runge-Kutta methods based on the Roessler SRI/SRA families. While completely independent and usable on its own, users wanting all SDE solvers should use [StochasticDiffEq.jl](https://github.com/SciML/StochasticDiffEq.jl).

## Solvers

### SRI Family (Stochastic Runge-Kutta for Ito SDEs)
- `SRI` - General SRI framework (user-supplied tableau)
- `SRIW1` - SRI with weak order 2 (strong order 1.5 for scalar/diagonal noise)
- `SRIW2` - SRI variant
- `SOSRI` - Stability-optimized SRI
- `SOSRI2` - Stability-optimized SRI variant

### SRA Family (Stochastic Runge-Kutta for additive noise)
- `SRA` - General SRA framework (user-supplied tableau)
- `SRA1` - SRA with strong order 1.5 for additive noise
- `SRA2` - SRA variant
- `SRA3` - SRA variant
- `SOSRA` - Stability-optimized SRA
- `SOSRA2` - Stability-optimized SRA variant

## Example

```julia
using StochasticDiffEqHighOrder
f(u, p, t) = 1.01 * u
g(u, p, t) = 0.87 * u
u0 = 0.5
tspan = (0.0, 1.0)
prob = SDEProblem(f, g, u0, tspan)
sol = solve(prob, SOSRI())
```

## Available Solvers

For the full list of available SDE solvers, refer to the [DifferentialEquations.jl SDE Solvers](https://docs.sciml.ai/DiffEqDocs/stable/solvers/sde_solve/) documentation.

## alg_order
alg_order(alg::SRI) = alg.tableau.order
alg_order(alg::SRIW1) = 3 // 2
alg_order(alg::SRIW2) = 3 // 2
alg_order(alg::SOSRI) = 3 // 2
alg_order(alg::SOSRI2) = 3 // 2
alg_order(alg::SRA) = alg.tableau.order
alg_order(alg::SRA1) = 2 // 1
alg_order(alg::SRA2) = 2 // 1
alg_order(alg::SRA3) = 2 // 1
alg_order(alg::SOSRA) = 2 // 1
alg_order(alg::SOSRA2) = 2 // 1

## delta_default
delta_default(alg::SRIW1) = 1 // 6

## alg_compatible
alg_compatible(prob::DiffEqBase.AbstractSDEProblem, alg::SRI) = is_diagonal_noise(prob)
alg_compatible(prob::DiffEqBase.AbstractSDEProblem, alg::SRIW1) = is_diagonal_noise(prob)
alg_compatible(prob::DiffEqBase.AbstractSDEProblem, alg::SRIW2) = is_diagonal_noise(prob)
alg_compatible(prob::DiffEqBase.AbstractSDEProblem, alg::SOSRI) = is_diagonal_noise(prob)
alg_compatible(prob::DiffEqBase.AbstractSDEProblem, alg::SOSRI2) = is_diagonal_noise(prob)
alg_compatible(prob::DiffEqBase.AbstractSDEProblem, alg::SRA) = true
alg_compatible(prob::DiffEqBase.AbstractSDEProblem, alg::SRA1) = true
alg_compatible(prob::DiffEqBase.AbstractSDEProblem, alg::SRA2) = true
alg_compatible(prob::DiffEqBase.AbstractSDEProblem, alg::SRA3) = true
alg_compatible(prob::DiffEqBase.AbstractSDEProblem, alg::SOSRA) = true
alg_compatible(prob::DiffEqBase.AbstractSDEProblem, alg::SOSRA2) = true

## alg_needs_extra_process
alg_needs_extra_process(alg::SRI) = true
alg_needs_extra_process(alg::SRIW1) = true
alg_needs_extra_process(alg::SRIW2) = true
alg_needs_extra_process(alg::SOSRI) = true
alg_needs_extra_process(alg::SOSRI2) = true
alg_needs_extra_process(alg::SRA) = true
alg_needs_extra_process(alg::SRA1) = true
alg_needs_extra_process(alg::SRA2) = true
alg_needs_extra_process(alg::SRA3) = true
alg_needs_extra_process(alg::SOSRA) = true
alg_needs_extra_process(alg::SOSRA2) = true

## alg_stability_size
alg_stability_size(alg::SOSRI2) = 10.6
alg_stability_size(alg::SOSRA2) = 5.3

#=
@muladd function perform_step!(integrator,cache::SRICache)
  (; c₀,c₁,A₀,A₁,B₀,B₁,α,β₁,β₂,β₃,β₄,stages,error_terms) = cache.tab
  (; H0,H1,A0temp,A1temp,B0temp,B1temp,A0temp2,A1temp2,B0temp2,B1temp2,atemp,btemp,E₁,E₂,E₁temp,ftemp,gtemp,chi1,chi2,chi3,tmp) = cache
  (; t,dt,uprev,u,W,p,f) = integrator
  @.. chi1 = .5*(W.dW.^2 - dt)/integrator.sqdt #I_(1,1)/sqrt(h)
  @.. chi2 = .5*(W.dW + W.dZ/sqrt3) #I_(1,0)/h
  @.. chi3 = 1/6 * (W.dW.^3 - 3*W.dW*dt)/dt #I_(1,1,1)/h
  for i=1:stages
    fill!(H0[i],zero(eltype(integrator.u)))
    fill!(H1[i],zero(eltype(integrator.u)))
  end
  for i = 1:stages
    fill!(A0temp,zero(eltype(integrator.u)))
    fill!(B0temp,zero(eltype(integrator.u)))
    fill!(A1temp,zero(eltype(integrator.u)))
    fill!(B1temp,zero(eltype(integrator.u)))
    for j = 1:i-1
      integrator.f((t + c₀[j]*dt),H0[j],ftemp)
      integrator.f.g((t + c₁[j]*dt),H1[j],gtemp)
      @.. A0temp = A0temp + A₀[j,i] * ftemp
      @.. B0temp = B0temp + B₀[j,i] * gtemp
      @.. A1temp = A1temp + A₁[j,i] * ftemp
      @.. B1temp = B1temp + B₁[j,i] * gtemp
    end
    @.. H0[i] = uprev + A0temp*dt + B0temp*chi2
    @.. H1[i] = uprev + A1temp*dt + B1temp*integrator.sqdt
  end
  fill!(atemp,zero(eltype(integrator.u)))
  fill!(btemp,zero(eltype(integrator.u)))
  fill!(E₂,zero(eltype(integrator.u)))
  fill!(E₁temp,zero(eltype(integrator.u)))
  for i = 1:stages
    integrator.f((t+c₀[i]*dt),H0[i],ftemp)
    integrator.f.g((t+c₁[i]*dt),H1[i],gtemp)
    @.. atemp = atemp + α[i] * ftemp
    @.. btemp = btemp + (β₁[i] * W.dW + β₂[i] * chi1) * gtemp
    @.. E₂    = E₂    + (β₃[i] * chi2 + β₄[i] * chi3) * gtemp
    if i <= error_terms
      @.. E₁temp += ftemp
    end
  end

  @.. u = uprev + (dt*atemp + btemp) + E₂

  if integrator.opts.adaptive
    @.. E₁ = dt * E₁temp

    calculate_residuals!(tmp, E₁, E₂, uprev, u, integrator.opts.abstol,
                         integrator.opts.reltol, integrator.opts.delta,
                         integrator.opts.internalnorm, t)
    integrator.EEst = integrator.opts.internalnorm(tmp, t)
  end
  integrator.u = u
end
=#

@muladd function perform_step!(integrator, cache::SRICache)
    (; c₀, c₁, A₀, A₁, B₀, B₁, α, β₁, β₂, β₃, β₄, stages, error_terms) = cache.tab
    (;
        H0, H1, A0temp, A1temp, B0temp, B1temp, A0temp2, A1temp2, B0temp2, B1temp2,
        atemp, btemp, E₁, E₂, E₁temp, ftemp, gtemp, chi1, chi2, chi3, tmp,
    ) = cache
    (; t, dt, uprev, u, W, p, f) = integrator

    sqrt3 = sqrt(3one(eltype(W.dW)))
    if W.dW isa Union{SArray, Number}
        chi1 = (W.dW .^ 2 - abs(dt)) / 2integrator.sqdt #I_(1,1)/sqrt(h)
        chi2 = (W.dW + W.dZ / sqrt3) / 2 #I_(1,0)/h
        chi3 = (W.dW .^ 3 - 3W.dW * dt) / 6dt #I_(1,1,1)/h
    else
        @.. chi1 = (W.dW .^ 2 - dt) / 2integrator.sqdt #I_(1,1)/sqrt(h)
        @.. chi2 = (W.dW + W.dZ / sqrt3) / 2 #I_(1,0)/h
        @.. chi3 = (W.dW .^ 3 - 3W.dW * dt) / 6dt #I_(1,1,1)/h
    end

    for i in 1:stages
        fill!(H0[i], zero(eltype(integrator.u)))
        fill!(H1[i], zero(eltype(integrator.u)))
    end
    for i in 1:stages
        fill!(A0temp, zero(eltype(integrator.u)))
        fill!(B0temp, zero(eltype(integrator.u)))
        fill!(A1temp, zero(eltype(integrator.u)))
        fill!(B1temp, zero(eltype(integrator.u)))
        for j in 1:(i - 1)
            integrator.f(ftemp, H0[j], p, t + c₀[j] * dt)
            integrator.f.g(gtemp, H1[j], p, t + c₁[j] * dt)
            @.. A0temp = A0temp + A₀[j, i] * ftemp
            @.. B0temp = B0temp + B₀[j, i] * gtemp
            @.. A1temp = A1temp + A₁[j, i] * ftemp
            @.. B1temp = B1temp + B₁[j, i] * gtemp
        end
        @.. H0[i] = uprev + A0temp * dt + B0temp * chi2
        @.. H1[i] = uprev + A1temp * dt + B1temp * integrator.sqdt
    end
    fill!(atemp, zero(eltype(integrator.u)))
    fill!(btemp, zero(eltype(integrator.u)))
    fill!(E₂, zero(eltype(integrator.u)))
    fill!(E₁temp, zero(eltype(integrator.u)))
    for i in 1:stages
        integrator.f(ftemp, H0[i], p, t + c₀[i] * dt)
        integrator.f.g(gtemp, H1[i], p, t + c₁[i] * dt)
        @.. atemp = atemp + α[i] * ftemp
        @.. btemp = btemp + (β₁[i] * W.dW + β₂[i] * chi1) * gtemp
        @.. E₂ = E₂ + (β₃[i] * chi2 + β₄[i] * chi3) * gtemp
        if i <= error_terms
            @.. E₁temp += ftemp
        end
    end

    @.. u = uprev + (dt * atemp + btemp) + E₂

    if integrator.opts.adaptive
        @.. E₁ = dt * E₁temp

        calculate_residuals!(
            tmp, E₁, E₂, uprev, u, integrator.opts.abstol,
            integrator.opts.reltol, integrator.opts.delta,
            integrator.opts.internalnorm, t
        )
        integrator.EEst = integrator.opts.internalnorm(tmp, t)
    end
end

#=
@muladd function perform_step!(integrator,cache::SRIW1Cache)
  (; t,dt,uprev,u,W,p,f) = integrator
  (; chi1,chi2,chi3,fH01o4,g₁o2,H0,H11,H12,H13,g₂o3,Fg₂o3,g₃o3,Tg₃o3,mg₁,E₁,E₂,fH01,fH02,g₁,g₂,g₃,g₄,tmp) = cache
  @.. chi1 = (W.dW.^2 - dt)/2integrator.sqdt #I_(1,1)/sqrt(h)
  @.. chi2 = (W.dW + W.dZ/sqrt3)/2 #I_(1,0)/h
  @.. chi3 = (W.dW.^3 - 3W.dW*dt)/6dt #I_(1,1,1)/h
  integrator.f(fH01,uprev,p,t)
  @.. fH01 = dt*fH01
  integrator.f.g(t,uprev,g₁)
  dto4 = dt/4
  @.. fH01o4 = fH01/4
  @.. g₁o2 = g₁/2
  @.. H0 =  uprev + 3 * (fH01o4 + chi2 * g₁o2)
  @.. H11 = uprev + fH01o4 + integrator.sqdt * g₁o2
  @.. H12 = uprev + fH01 - integrator.sqdt * g₁
  integrator.f.g(t+dto4,H11,g₂)
  integrator.f.g(t+dt,H12,g₃)
  @.. H13 = uprev + fH01o4 + integrator.sqdt * (-5 * g₁ + 3 * g₂ + g₃ / 2)

  integrator.f.g(t+dto4,H13,g₄)
  integrator.f(fH02,H0,p,t+3dto4)

  @.. fH02 = fH02*dt
  @.. g₂o3 = g₂/3
  @.. Fg₂o3 = 4g₂o3
  @.. g₃o3 = g₃/3
  @.. Tg₃o3 = 2g₃o3
  @.. mg₁ = -g₁
  @.. E₂ = chi2 * (2 * g₁ - Fg₂o3 - Tg₃o3) + chi3 * (2 * mg₁ + 5 * g₂o3 - Tg₃o3 + g₄)

  @.. u = uprev +  (fH01 + 2 * fH02) / 3 + W.dW * (mg₁ + Fg₂o3 + Tg₃o3) + chi1 * (mg₁ + Fg₂o3 - g₃o3) + E₂

  if integrator.opts.adaptive
    @.. E₁ = fH01 + fH02

    calculate_residuals!(tmp, E₁, E₂, uprev, u, integrator.opts.abstol,
                         integrator.opts.reltol, integrator.opts.delta,
                         integrator.opts.internalnorm, t)
    integrator.EEst = integrator.opts.internalnorm(tmp, t)
  end
  integrator.u = u
end
=#

@muladd function perform_step!(integrator, cache::SRIW1Cache)
    (; t, dt, uprev, u, W, p, f) = integrator
    (;
        chi1, chi2, chi3, fH01o4, g₁o2, H0, H11, H12, H13, g₂o3, Fg₂o3, g₃o3,
        Tg₃o3, mg₁, E₁, E₂, fH01, fH02, g₁, g₂, g₃, g₄, tmp,
    ) = cache

    sqrt3 = sqrt(3one(eltype(W.dW)))
    if W.dW isa Union{SArray, Number}
        chi1 = (W.dW .^ 2 - abs(dt)) / 2integrator.sqdt #I_(1,1)/sqrt(h)
        chi2 = (W.dW + W.dZ / sqrt3) / 2 #I_(1,0)/h
        chi3 = (W.dW .^ 3 - 3W.dW * dt) / 6dt #I_(1,1,1)/h
    else
        @.. chi1 = (W.dW .^ 2 - dt) / 2integrator.sqdt #I_(1,1)/sqrt(h)
        @.. chi2 = (W.dW + W.dZ / sqrt3) / 2 #I_(1,0)/h
        @.. chi3 = (W.dW .^ 3 - 3W.dW * dt) / 6dt #I_(1,1,1)/h
    end

    integrator.f(fH01, uprev, p, t)
    @.. fH01 = dt * fH01
    integrator.f.g(g₁, uprev, p, t)
    dto4 = dt / 4

    @.. fH01o4 = fH01 / 4
    @.. g₁o2 = g₁ / 2
    @.. H0 = uprev + 3 * (fH01o4 + chi2 * g₁o2)
    @.. H11 = uprev + fH01o4 + integrator.sqdt * g₁o2
    @.. H12 = uprev + fH01 - integrator.sqdt * g₁

    integrator.f.g(g₂, H11, p, t + dto4)
    integrator.f.g(g₃, H12, p, t + dt)

    @.. H13 = uprev + fH01o4 + integrator.sqdt * (-5g₁ + 3g₂ + g₃ / 2)

    integrator.f.g(g₄, H13, p, t + dto4)
    integrator.f(fH02, H0, p, t + 3dto4)

    @.. fH02 = fH02 * dt
    @.. g₂o3 = g₂ / 3
    @.. Fg₂o3 = 4g₂o3
    @.. g₃o3 = g₃ / 3
    @.. Tg₃o3 = 2g₃o3
    @.. mg₁ = -g₁

    @.. E₂ = chi2 * (2 * g₁ - Fg₂o3 - Tg₃o3) + chi3 * (2 * mg₁ + 5 * g₂o3 - Tg₃o3 + g₄)

    @.. u = uprev + (fH01 + 2 * fH02) / 3 + W.dW * (mg₁ + Fg₂o3 + Tg₃o3) + chi1 * (mg₁ + Fg₂o3 - g₃o3) + E₂

    if integrator.opts.adaptive
        @.. E₁ = fH01 + fH02

        calculate_residuals!(
            tmp, E₁, E₂, uprev, u, integrator.opts.abstol,
            integrator.opts.reltol, integrator.opts.delta,
            integrator.opts.internalnorm, t
        )
        integrator.EEst = integrator.opts.internalnorm(tmp, t)
    end
end

@muladd function perform_step!(integrator, cache::SRIW1ConstantCache)
    (; t, dt, uprev, u, W, p, f) = integrator
    sqrt3 = sqrt(3one(eltype(W.dW)))
    chi1 = @.. (W.dW .^ 2 - abs(dt)) / 2integrator.sqdt #I_(1,1)/sqrt(h)
    chi2 = @.. (W.dW + W.dZ / sqrt3) / 2 #I_(1,0)/h
    chi3 = @.. (W.dW .^ 3 - 3W.dW * dt) / 6dt #I_(1,1,1)/h
    fH01 = dt * integrator.f(uprev, p, t)

    g₁ = integrator.f.g(uprev, p, t)
    fH01o4 = fH01 / 4
    dto4 = dt / 4
    g₁o2 = g₁ / 2
    H0 = @.. uprev + 3 * (fH01o4 + chi2 * g₁o2)
    H11 = @.. uprev + fH01o4 + integrator.sqdt * g₁o2
    H12 = @.. uprev + fH01 - integrator.sqdt * g₁
    g₂ = integrator.f.g(H11, p, t + dto4)
    g₃ = integrator.f.g(H12, p, t + dt)
    H13 = @.. uprev + fH01o4 + integrator.sqdt * (-5 * g₁ + 3 * g₂ + g₃ / 2)

    g₄ = integrator.f.g(H13, p, t + dto4)
    fH02 = dt * integrator.f(H0, p, t + 3dto4)

    g₂o3 = g₂ / 3
    Fg₂o3 = 4g₂o3
    g₃o3 = g₃ / 3
    Tg₃o3 = 2g₃o3
    mg₁ = -g₁
    E₂ = @.. chi2 * (2 * g₁ - Fg₂o3 - Tg₃o3) + chi3 * (2 * mg₁ + 5 * g₂o3 - Tg₃o3 + g₄)

    u = uprev + (fH01 + 2fH02) / 3 + W.dW .* (mg₁ + Fg₂o3 + Tg₃o3) + chi1 .* (mg₁ + Fg₂o3 - g₃o3) + E₂
    if integrator.opts.adaptive
        E₁ = fH01 .+ fH02

        resids = calculate_residuals(
            E₁, E₂, uprev, u, integrator.opts.abstol,
            integrator.opts.reltol, integrator.opts.delta,
            integrator.opts.internalnorm, t
        )
        integrator.EEst = integrator.opts.internalnorm(resids, t)
    end
    integrator.u = u
end

@muladd function perform_step!(integrator, cache::SRIConstantCache)
    (; t, dt, uprev, u, W, p, f) = integrator
    (; c₀, c₁, A₀, A₁, B₀, B₁, α, β₁, β₂, β₃, β₄, stages, H0, H1, error_terms) = cache
    sqrt3 = sqrt(3one(eltype(W.dW)))
    chi1 = 0.5 * (W.dW .^ 2 - abs(dt)) / integrator.sqdt #I_(1,1)/sqrt(h)
    chi2 = 0.5 * (W.dW + W.dZ / sqrt3) #I_(1,0)/h
    chi3 = 1 / 6 * (W.dW .^ 3 - 3 * W.dW * dt) / dt #I_(1,1,1)/h

    fill!(H0, zero(u))
    fill!(H1, zero(u))
    @inbounds for i in 1:stages
        A0temp = zero(u)
        B0temp = zero(u)
        A1temp = zero(u)
        B1temp = zero(u)
        for j in 1:(i - 1)
            ftmp = integrator.f(H0[j], p, t + c₀[j] * dt)
            A0temp = @.. A0temp + A₀[j, i] * ftmp
            A1temp = @.. A1temp + A₁[j, i] * ftmp

            gtmp = integrator.f.g(H1[j], p, t + c₁[j] * dt)
            B0temp = @.. B0temp + B₀[j, i] * gtmp
            B1temp = @.. B1temp + B₁[j, i] * gtmp
        end
        H0[i] = @.. uprev + dt * A0temp + chi2 * B0temp
        H1[i] = @.. uprev + dt * A1temp + integrator.sqdt * B1temp
    end
    atemp = zero(u)
    btemp = zero(u)
    E₂ = zero(u)
    E₁temp = zero(u)
    @inbounds for i in 1:stages
        ftmp = integrator.f(H0[i], p, t + c₀[i] * dt)
        atemp = @.. atemp + α[i] * ftmp

        gtmp = integrator.f.g(H1[i], p, t + c₁[i] * dt)
        btemp = @.. btemp + (β₁[i] * W.dW + β₂[i] * chi1) * gtmp
        E₂ = @.. E₂ + (β₃[i] * chi2 + β₄[i] * chi3) * gtmp
        if i <= error_terms #1 or 2
            E₁temp = E₁temp .+ ftmp
        end
    end

    u = (uprev + dt * atemp) + btemp + E₂

    if integrator.opts.adaptive
        E₁ = dt .* E₁temp

        resids = calculate_residuals(
            E₁, E₂, uprev, u, integrator.opts.abstol,
            integrator.opts.reltol, integrator.opts.delta,
            integrator.opts.internalnorm, t
        )
        integrator.EEst = integrator.opts.internalnorm(resids, t)
    end
    integrator.u = u
end

@muladd function perform_step!(integrator, cache::FourStageSRIConstantCache)
    (; t, dt, uprev, u, W, p, f) = integrator
    (;
        a021,
        a031, a032, a041, a042, a043, a121, a131, a132, a141, a142, a143, b021, b031, b032,
        b041, b042, b043, b121, b131, b132, b141, b142, b143, c02, c03, c04, c11, c12,
        c13, c14, α1, α2, α3, α4, beta11, beta12, beta13, beta14, beta21, beta22, beta23,
        beta24, beta31, beta32, beta33, beta34, beta41, beta42, beta43, beta44,
    ) = cache

    sqrt3 = sqrt(3one(eltype(W.dW)))
    chi1 = (W.dW .^ 2 .- abs(dt)) / (2integrator.sqdt) #I_(1,1)/sqrt(h)
    chi2 = (W.dW .+ W.dZ ./ sqrt3) ./ 2 #I_(1,0)/h
    chi3 = (W.dW .^ 3 .- 3 * W.dW * dt) / (6dt) #I_(1,1,1)/h

    k1 = integrator.f(uprev, p, t)
    g1 = integrator.f.g(uprev, p, t + c11 * dt)

    H01 = uprev + dt * a021 * k1 + b021 * chi2 .* g1
    H11 = uprev + dt * a121 * k1 + integrator.sqdt * b121 * g1

    k2 = integrator.f(H01, p, t + c02 * dt)
    g2 = integrator.f.g(H11, p, t + c12 * dt)

    H02 = uprev + dt * (a031 * k1 + a032 * k2) + chi2 .* (b031 * g1 + b032 * g2)
    H12 = uprev + dt * (a131 * k1 + a132 * k2) + integrator.sqdt * (b131 * g1 + b132 * g2)

    k3 = integrator.f(H02, p, t + c03 * dt)
    g3 = integrator.f.g(H12, p, t + c13 * dt)

    H03 = uprev + dt * (a041 * k1 + a042 * k2 + a043 * k3) + chi2 .* (b041 * g1 + b042 * g2 + b043 * g3)
    H13 = uprev + dt * (a141 * k1 + a142 * k2 + a143 * k3) + integrator.sqdt * (b141 * g1 + b142 * g2 + b143 * g3)

    k4 = integrator.f(H03, p, t + c04 * dt)
    g4 = integrator.f.g(H13, p, t + c14 * dt)

    E₂ = chi2 .* (beta31 * g1 + beta32 * g2 + beta33 * g3 + beta34 * g4) + chi3 .* (beta41 * g1 + beta42 * g2 + beta43 * g3 + beta44 * g4)

    u = uprev + dt * (α1 * k1 + α2 * k2 + α3 * k3 + α4 * k4) + E₂ + W.dW .* (beta11 * g1 + beta12 * g2 + beta13 * g3 + beta14 * g4) + chi1 .* (beta21 * g1 + beta22 * g2 + beta23 * g3 + beta24 * g4)

    E₁ = dt * (k1 + k2 + k3 + k4)

    if integrator.alg isa StochasticCompositeAlgorithm && integrator.alg.algs[1] isa SOSRI2
        ϱu = integrator.opts.internalnorm(k4 - k3, t)
        ϱd = integrator.opts.internalnorm(H03 - H02, t)
        integrator.eigen_est = ϱu / ϱd
    end

    if integrator.opts.adaptive
        E₁ = @.. dt * (k1 + k2 + k3 + k4)

        resids = calculate_residuals(
            E₁, E₂, uprev, u, integrator.opts.abstol,
            integrator.opts.reltol, integrator.opts.delta,
            integrator.opts.internalnorm, t
        )
        integrator.EEst = integrator.opts.internalnorm(resids, t)
    end
    integrator.u = u
end

@muladd function perform_step!(integrator, cache::FourStageSRICache)
    (; t, dt, uprev, u, W, p, f) = integrator
    (;
        chi1, chi2, chi3, tab, g1, g2, g3, g4, k1, k2, k3, k4, E₁, E₂, tmp, H02,
        H03,
    ) = cache
    (;
        a021,
        a031, a032, a041, a042, a043, a121, a131, a132, a141, a142, a143, b021, b031, b032,
        b041, b042, b043, b121, b131, b132, b141, b142, b143, c02, c03, c04, c11, c12,
        c13, c14, α1, α2, α3, α4, beta11, beta12, beta13, beta14, beta21, beta22, beta23,
        beta24, beta31, beta32, beta33, beta34, beta41, beta42, beta43, beta44,
    ) = cache.tab

    sqdt = integrator.sqdt
    sqrt3 = sqrt(3one(eltype(W.dW)))
    if W.dW isa Union{SArray, Number}
        chi1 = (W.dW .^ 2 - abs(dt)) / 2integrator.sqdt #I_(1,1)/sqrt(h)
        chi2 = (W.dW + W.dZ / sqrt3) / 2 #I_(1,0)/h
        chi3 = (W.dW .^ 3 - 3W.dW * dt) / 6dt #I_(1,1,1)/h
    else
        @.. chi1 = (W.dW .^ 2 - dt) / 2integrator.sqdt #I_(1,1)/sqrt(h)
        @.. chi2 = (W.dW + W.dZ / sqrt3) / 2 #I_(1,0)/h
        @.. chi3 = (W.dW .^ 3 - 3W.dW * dt) / 6dt #I_(1,1,1)/h
    end

    integrator.f(k1, uprev, p, t)
    integrator.f.g(g1, uprev, p, t + c11 * dt)

    @.. tmp = uprev + dt * a021 * k1 + chi2 * b021 * g1
    integrator.f(k2, tmp, p, t + c02 * dt)

    @.. tmp = uprev + dt * a121 * k1 + sqdt * b121 * g1
    integrator.f.g(g2, tmp, p, t + c12 * dt)

    @.. H02 = uprev + dt * (a031 * k1 + a032 * k2) + chi2 * (b031 * g1 + b032 * g2)
    integrator.f(k3, H02, p, t + c03 * dt)
    @.. tmp = uprev + dt * (a131 * k1 + a132 * k2) + sqdt * (b131 * g1 + b132 * g2)
    integrator.f.g(g3, tmp, p, t + c13 * dt)

    @.. H03 = uprev + dt * (a041 * k1 + a042 * k2 + a043 * k3) + chi2 * (b041 * g1 + b042 * g2 + b043 * g3)
    integrator.f(k4, H03, p, t + c04 * dt)

    @.. tmp = uprev + dt * (a141 * k1 + a142 * k2 + a143 * k3) + sqdt * (b141 * g1 + b142 * g2 + b143 * g3)
    integrator.f.g(g4, tmp, p, t + c14 * dt)

    if integrator.alg isa StochasticCompositeAlgorithm && integrator.alg.algs[1] isa SOSRI2
        @.. tmp = k4 - k3
        ϱu = integrator.opts.internalnorm(tmp, t)
        @.. tmp = H03 - H02
        ϱd = integrator.opts.internalnorm(tmp, t)
        integrator.eigen_est = ϱu / ϱd
    end

    @.. E₂ = chi2 * (beta31 * g1 + beta32 * g2 + beta33 * g3 + beta34 * g4) + chi3 * (beta41 * g1 + beta42 * g2 + beta43 * g3 + beta44 * g4)
    @.. u = uprev + dt * (α1 * k1 + α2 * k2 + α3 * k3 + α4 * k4) + E₂ + W.dW * (beta11 * g1 + beta12 * g2 + beta13 * g3 + beta14 * g4) + chi1 * (beta21 * g1 + beta22 * g2 + beta23 * g3 + beta24 * g4)

    if integrator.opts.adaptive
        @.. E₁ = dt * (k1 + k2 + k3 + k4)

        calculate_residuals!(
            tmp, E₁, E₂, uprev, u, integrator.opts.abstol,
            integrator.opts.reltol, integrator.opts.delta,
            integrator.opts.internalnorm, t
        )
        integrator.EEst = integrator.opts.internalnorm(tmp, t)
    end
end

@muladd function perform_step!(integrator, cache::SRA1ConstantCache)
    (; t, dt, uprev, u, W, p, f) = integrator
    gpdt = integrator.f.g(uprev, p, t + dt)
    sqrt3 = sqrt(3one(eltype(W.dW)))
    chi2 = (W.dW + W.dZ / sqrt3) / 2 #I_(1,0)/h
    k₁ = dt * integrator.f(uprev, p, t)
    k₂ = dt * integrator.f(uprev + 3k₁ / 4 + 3chi2 .* gpdt / 2, p, t + 3dt / 4)
    E₂ = chi2 .* (integrator.f.g(uprev, p, t) - gpdt) #Only for additive!
    u = @.. uprev + k₁ / 3 + 2 * k₂ / 3 + E₂ + W.dW * gpdt

    if integrator.opts.adaptive
        E₁ = k₁ .+ k₂

        resids = calculate_residuals(
            E₁, E₂, uprev, u, integrator.opts.abstol,
            integrator.opts.reltol, integrator.opts.delta,
            integrator.opts.internalnorm, t
        )
        integrator.EEst = integrator.opts.internalnorm(resids, t)
    end
    integrator.u = u
end

#=
@muladd function perform_step!(integrator,cache::SRA1Cache)
  (; chi2,tmp1,E₁,E₂,gt,k₁,k₂,gpdt,tmp) = cache
  (; t,dt,uprev,u,W,p,f) = integrator
  integrator.f.g(t,uprev,gt)
  integrator.f.g(t+dt,uprev,gpdt)
  integrator.f(t,uprev,k₁); k₁*=dt
  @.. chi2 = (W.dW + W.dZ/sqrt3)/2 #I_(1,0)/h
  @.. tmp1 = uprev+3k₁/4 + 3chi2*gpdt/2

  integrator.f(t+3dt/4,tmp1,k₂); k₂*=dt

  @.. E₂ = chi2*(gt-gpdt) #Only for additive!

  @.. u = uprev + k₁/3 + 2k₂/3 + E₂ + W.dW*gpdt

  if integrator.opts.adaptive
    @.. E₁ = k₁ + k₂

    calculate_residuals!(tmp, E₁, E₂, uprev, u, integrator.opts.abstol,
                         integrator.opts.reltol, integrator.opts.delta,
                         integrator.opts.internalnorm, t)
    integrator.EEst = integrator.opts.internalnorm(tmp, t)
  end
  integrator.u = u
end
=#

@muladd function perform_step!(integrator, cache::SRA1Cache)
    (; chi2, tmp1, E₁, E₂, gt, k₁, k₂, gpdt, tmp) = cache
    (; t, dt, uprev, u, W, p, f) = integrator
    integrator.f.g(gt, uprev, p, t)
    integrator.f.g(gpdt, uprev, p, t + dt)
    integrator.f(k₁, uprev, p, t)
    k₁ *= dt
    sqrt3 = sqrt(3one(eltype(W.dW)))
    if W.dW isa Union{SArray, Number}
        chi2 = (W.dW + W.dZ / sqrt3) / 2 #I_(1,0)/h
    else
        @.. chi2 = (W.dW + W.dZ / sqrt3) / 2 #I_(1,0)/h
    end

    if is_diagonal_noise(integrator.sol.prob)
        @.. E₁ = chi2 * gpdt
        @.. E₂ = chi2 * (gt - gpdt) #Only for additive!
    else
        mul!(E₁, gpdt, chi2)
        @.. gt -= gpdt
        mul!(E₂, gt, chi2)
    end

    @.. tmp1 = uprev + 3k₁ / 4 + 3E₁ / 2

    integrator.f(k₂, tmp1, p, t + 3dt / 4)
    @.. k₂ *= dt

    if is_diagonal_noise(integrator.sol.prob)
        @.. tmp1 = W.dW * gpdt
    else
        mul!(tmp1, gpdt, W.dW)
    end

    @.. u = uprev + k₁ / 3 + 2k₂ / 3 + E₂ + tmp1

    if integrator.opts.adaptive
        @.. E₁ = k₁ + k₂

        calculate_residuals!(
            tmp, E₁, E₂, uprev, u, integrator.opts.abstol,
            integrator.opts.reltol, integrator.opts.delta,
            integrator.opts.internalnorm, t
        )
        integrator.EEst = integrator.opts.internalnorm(tmp, t)
    end
end

@muladd function perform_step!(integrator, cache::SRA2ConstantCache)
    (; t, dt, uprev, u, W, p, f) = integrator
    (; a21, b21, c02, c11, c12, α1, α2, beta12, beta21, beta22) = cache
    sqrt3 = sqrt(3one(eltype(W.dW)))
    chi2 = 0.5 * (W.dW + W.dZ / sqrt3) #I_(1,0)/h

    g1 = integrator.f.g(uprev, p, t + c11 * dt)
    k1 = integrator.f(uprev, p, t)
    H01 = uprev + dt * a21 * k1 + chi2 * b21 * g1

    g2 = integrator.f.g(H01, p, t + c12 * dt)
    k2 = integrator.f(H01, p, t + c02 * dt)

    E₁ = dt * (α1 * k1 + α2 * k2)
    E₂ = chi2 * (beta21 * g1 + beta22 * g2)

    u = uprev + E₁ + E₂ + W.dW * (beta12 * g2)

    if integrator.opts.adaptive
        E₁ = @.. dt * (k1 + k2)

        resids = calculate_residuals(
            E₁, E₂, uprev, u, integrator.opts.abstol,
            integrator.opts.reltol, integrator.opts.delta,
            integrator.opts.internalnorm, t
        )
        integrator.EEst = integrator.opts.internalnorm(resids, t)
    end
    integrator.u = u
end

@muladd function perform_step!(integrator, cache::SRA2Cache)
    (; t, dt, uprev, u, W, p, f) = integrator
    (; chi2, tab, g1, g2, k1, k2, E₁, E₂, tmp) = cache
    (; a21, b21, c02, c11, c12, α1, α2, beta12, beta21, beta22) = cache.tab
    H01 = E₁
    sqrt3 = sqrt(3one(eltype(W.dW)))
    if W.dW isa Union{SArray, Number}
        chi2 = (W.dW + W.dZ / sqrt3) / 2 #I_(1,0)/h
    else
        @.. chi2 = (W.dW + W.dZ / sqrt3) / 2 #I_(1,0)/h
    end

    integrator.f.g(g1, uprev, p, t + c11 * dt)
    integrator.f(k1, uprev, p, t)

    if is_diagonal_noise(integrator.sol.prob)
        @.. H01 = uprev + dt * a21 * k1 + chi2 * b21 * g1
    else
        mul!(E₁, g1, chi2)
        @.. H01 = uprev + dt * a21 * k1 + b21 * E₁
    end

    integrator.f.g(g2, H01, p, t + c12 * dt)
    integrator.f(k2, H01, p, t + c02 * dt)

    if is_diagonal_noise(integrator.sol.prob)
        @.. E₂ = chi2 * (beta21 * g1 + beta22 * g2)
        @.. u = uprev + dt * (α1 * k1 + α2 * k2) + E₂ + W.dW * (beta12 * g2)
    else
        @.. g1 = beta21 * g1 + beta22 * g2
        mul!(E₂, g1, chi2)
        g2 .*= beta12
        mul!(E₁, g2, W.dW)
        @.. u = uprev + dt * (α1 * k1 + α2 * k2) + E₂ + E₁
    end

    if integrator.opts.adaptive
        @.. E₁ = dt * (k1 + k2)

        calculate_residuals!(
            tmp, E₁, E₂, uprev, u, integrator.opts.abstol,
            integrator.opts.reltol, integrator.opts.delta,
            integrator.opts.internalnorm, t
        )
        integrator.EEst = integrator.opts.internalnorm(tmp, t)
    end
end

@muladd function perform_step!(integrator, cache::ThreeStageSRAConstantCache)
    (; t, dt, uprev, u, W, p, f) = integrator
    (;
        a21, a31, a32, b21, b31, b32, c02, c03, c11, c12, c13, α1, α2,
        α3, beta11, beta12, beta13, beta21, beta22, beta23,
    ) = cache
    sqrt3 = sqrt(3one(eltype(W.dW)))
    chi2 = 0.5 * (W.dW .+ W.dZ / sqrt3) #I_(1,0)/h

    g1 = integrator.f.g(uprev, p, t + c11 * dt)
    k1 = integrator.f(uprev, p, t)

    if is_diagonal_noise(integrator.sol.prob)
        H01 = uprev + dt * a21 * k1 + b21 * chi2 .* g1
    else
        H01 = uprev + dt * a21 * k1 + b21 * g1 * chi2
    end

    g2 = integrator.f.g(H01, p, t + c12 * dt)
    k2 = integrator.f(H01, p, t + c02 * dt)

    if is_diagonal_noise(integrator.sol.prob)
        H02 = uprev + dt * (a31 * k1 + a32 * k2) + chi2 .* (b31 * g1 + b32 * g2)
    else
        H02 = uprev + dt * (a31 * k1 + a32 * k2) + (b31 * g1 + b32 * g2) * chi2
    end

    g3 = integrator.f.g(H02, p, t + c13 * dt)
    k3 = integrator.f(H02, p, t + c03 * dt)

    E₁ = dt * (α1 * k1 + α2 * k2 + α3 * k3)

    if is_diagonal_noise(integrator.sol.prob)
        E₂ = chi2 .* (beta21 * g1 + beta22 * g2 + beta23 * g3)
        u = uprev + E₁ + E₂ + W.dW .* (beta11 * g1 + beta12 * g2 + beta13 * g3)
    else
        E₂ = (beta21 * g1 + beta22 * g2 + beta23 * g3) * chi2
        u = uprev + E₁ + E₂ + (beta11 * g1 + beta12 * g2 + beta13 * g3) * W.dW
    end

    if integrator.alg isa StochasticCompositeAlgorithm && integrator.alg.algs[1] isa SOSRA2
        ϱu = integrator.opts.internalnorm(k3 - k2, t)
        ϱd = integrator.opts.internalnorm(H02 - H01, t)
        integrator.eigen_est = ϱu / ϱd
    end

    if integrator.opts.adaptive
        E₁ = @.. dt * (k1 + k2 + k3)

        resids = calculate_residuals(
            E₁, E₂, uprev, u, integrator.opts.abstol,
            integrator.opts.reltol, integrator.opts.delta,
            integrator.opts.internalnorm, t
        )
        integrator.EEst = integrator.opts.internalnorm(resids, t)
    end
    integrator.u = u
end

@muladd function perform_step!(integrator, cache::ThreeStageSRACache)
    (; t, dt, uprev, u, W, p, f) = integrator
    (; chi2, tab, g1, g2, g3, k1, k2, k3, E₁, E₂, tmp, gtmp) = cache
    (;
        a21, a31, a32, b21, b31, b32, c02, c03, c11, c12, c13, α1, α2, α3,
        beta11, beta12, beta13, beta21, beta22, beta23,
    ) = cache.tab

    H01 = E₁
    H02 = E₁
    sqrt3 = sqrt(3one(eltype(W.dW)))
    if W.dW isa Union{SArray, Number}
        chi2 = (W.dW + W.dZ / sqrt3) / 2 #I_(1,0)/h
    else
        @.. chi2 = (W.dW + W.dZ / sqrt3) / 2 #I_(1,0)/h
    end

    integrator.f.g(g1, uprev, p, t + c11 * dt)
    integrator.f(k1, uprev, p, t)

    if is_diagonal_noise(integrator.sol.prob)
        @.. H01 = uprev + dt * a21 * k1 + chi2 * b21 * g1
    else
        mul!(E₁, g1, chi2)
        @.. H01 = uprev + dt * a21 * k1 + b21 * E₁
    end

    integrator.f.g(g2, H01, p, t + c12 * dt)
    integrator.f(k2, H01, p, t + c02 * dt)

    if is_diagonal_noise(integrator.sol.prob)
        @.. H02 = uprev + dt * (a31 * k1 + a32 * k2) + chi2 * (b31 * g1 + b32 * g2)
    else
        @.. gtmp = b31 * g1 + b32 * g2
        mul!(E₁, gtmp, chi2)
        @.. H02 = uprev + dt * (a31 * k1 + a32 * k2) + E₁
    end

    integrator.f.g(g3, H02, p, t + c13 * dt)
    integrator.f(k3, H02, p, t + c03 * dt)

    if is_diagonal_noise(integrator.sol.prob)
        @.. E₂ = chi2 * (beta21 * g1 + beta22 * g2 + beta23 * g3)
        @.. u = uprev + dt * (α1 * k1 + α2 * k2 + α3 * k3) + E₂ +
            W.dW * (beta11 * g1 + beta12 * g2 + beta13 * g3)
    else
        @.. gtmp = beta21 * g1 + beta22 * g2 + beta23 * g3
        mul!(E₂, gtmp, chi2)
        @.. gtmp = beta11 * g1 + beta12 * g2 + beta13 * g3
        mul!(E₁, gtmp, W.dW)
        @.. u = uprev + dt * (α1 * k1 + α2 * k2 + α3 * k3) + E₂ + E₁
    end

    if integrator.alg isa StochasticCompositeAlgorithm && integrator.alg.algs[1] isa SOSRA2
        @.. tmp = k3 - k2
        ϱu = integrator.opts.internalnorm(tmp, t)
        @.. tmp = H02 - H01
        ϱd = integrator.opts.internalnorm(tmp, t)
        integrator.eigen_est = ϱu / ϱd
    end

    if integrator.opts.adaptive
        @.. E₁ = dt * (k1 + k2 + k3)

        calculate_residuals!(
            tmp, E₁, E₂, uprev, u, integrator.opts.abstol,
            integrator.opts.reltol, integrator.opts.delta,
            integrator.opts.internalnorm, t
        )
        integrator.EEst = integrator.opts.internalnorm(tmp, t)
    end
    nothing
end

#=
@muladd function perform_step!(integrator,cache::SRACache)
  (; t,dt,uprev,u,W,p,f) = integrator
  (; H0,A0temp,B0temp,ftmp,gtmp,chi2,atemp,btemp,E₁,E₁temp,E₂,tmp) = cache
  (; c₀,c₁,A₀,B₀,α,β₁,β₂,stages) = cache.tab
  @.. chi2 = .5*(W.dW + W.dZ/sqrt3) #I_(1,0)/h
  for i in 1:stages
    fill!(H0[i],zero(eltype(integrator.u)))
  end
  for i = 1:stages
    fill!(A0temp,zero(eltype(integrator.u)))
    fill!(B0temp,zero(eltype(integrator.u)))
    for j = 1:i-1
      integrator.f((t + c₀[j]*dt),H0[j],ftmp)
      integrator.f.g((t + c₁[j]*dt),H0[j],gtmp)
      @.. A0temp = A0temp + A₀[j,i] * ftmp
      @.. B0temp = B0temp + B₀[j,i] * gtmp
    end
    @.. H0[i] = uprev + dt * A0temp + chi2 * B0temp
  end
  fill!(atemp ,zero(eltype(integrator.u)))
  fill!(btemp ,zero(eltype(integrator.u)))
  fill!(E₂    ,zero(eltype(integrator.u)))
  fill!(E₁temp,zero(eltype(integrator.u)))

  for i = 1:stages
    integrator.f((t+c₀[i]*dt),H0[i],ftmp)
    integrator.f.g((t+c₁[i]*dt),H0[i],gtmp)
    @.. atemp  =  atemp  + α[i] * ftmp
    @.. btemp  =  btemp  + (β₁[i] * W.dW) * gtmp
    @.. E₂     =  E₂     + (β₂[i] * chi2) * gtmp
    @.. E₁temp =  E₁temp +  ftmp
  end
  @.. u = uprev + dt * atemp + btemp + E₂

  if integrator.opts.adaptive
    @.. E₁ = dt*E₁temp

    calculate_residuals!(tmp, E₁, E₂, uprev, u, integrator.opts.abstol,
                         integrator.opts.reltol, integrator.opts.delta,
                         integrator.opts.internalnorm, t)
    integrator.EEst = integrator.opts.internalnorm(tmp, t)
  end
  integrator.u = u
end
=#

@muladd function perform_step!(integrator, cache::SRACache)
    (; t, dt, uprev, u, W, p, f) = integrator
    (; H0, A0temp, B0temp, ftmp, gtmp, chi2, atemp, btemp, E₁, E₁temp, E₂, tmp) = cache
    (; c₀, c₁, A₀, B₀, α, β₁, β₂, stages) = cache.tab
    sqrt3 = sqrt(3one(eltype(W.dW)))
    if W.dW isa Union{SArray, Number}
        chi2 = (W.dW + W.dZ / sqrt3) / 2 #I_(1,0)/h
    else
        @.. chi2 = (W.dW + W.dZ / sqrt3) / 2 #I_(1,0)/h
    end

    for i in 1:stages
        fill!(H0[i], zero(eltype(integrator.u)))
    end
    for i in 1:stages
        fill!(A0temp, zero(eltype(integrator.u)))
        fill!(B0temp, zero(eltype(integrator.u)))
        for j in 1:(i - 1)
            integrator.f(ftmp, H0[j], p, t + c₀[j] * dt)
            integrator.f.g(gtmp, H0[j], p, t + c₁[j] * dt)
            @.. A0temp = A0temp + A₀[j, i] * ftmp
            if is_diagonal_noise(integrator.sol.prob)
                @.. B0temp = B0temp + B₀[j, i] * chi2 * gtmp
            else
                mul!(E₁temp, gtmp, chi2)
                @.. B0temp = B0temp + B₀[j, i] * E₁temp
            end
        end

        @.. H0[i] = uprev + dt * A0temp + B0temp
    end
    fill!(atemp, zero(eltype(integrator.u)))
    fill!(btemp, zero(eltype(integrator.u)))
    fill!(E₂, zero(eltype(integrator.u)))
    fill!(E₁temp, zero(eltype(integrator.u)))

    for i in 1:stages
        integrator.f(ftmp, H0[i], p, t + c₀[i] * dt)
        integrator.f.g(gtmp, H0[i], p, t + c₁[i] * dt)
        if is_diagonal_noise(integrator.sol.prob)
            @.. btemp = btemp + β₁[i] * W.dW * gtmp
        else
            mul!(E₁temp, gtmp, W.dW)
            @.. btemp = btemp + β₁[i] * E₁temp
        end
        if is_diagonal_noise(integrator.sol.prob)
            @.. E₂ = E₂ + β₂[i] * chi2 * gtmp
        else
            mul!(E₁temp, gtmp, chi2)
            @.. E₂ = E₂ + β₂[i] * E₁temp
        end

        @.. atemp = atemp + α[i] * ftmp
        @.. E₁temp = E₁temp + ftmp
    end

    @.. u = uprev + dt * atemp + btemp + E₂

    if integrator.opts.adaptive
        @.. E₁ = dt * E₁temp

        calculate_residuals!(
            tmp, E₁, E₂, uprev, u, integrator.opts.abstol,
            integrator.opts.reltol, integrator.opts.delta,
            integrator.opts.internalnorm, t
        )
        integrator.EEst = integrator.opts.internalnorm(tmp, t)
    end
end

@muladd function perform_step!(integrator, cache::SRAConstantCache)
    (; c₀, c₁, A₀, B₀, α, β₁, β₂, stages, H0) = cache
    (; t, dt, uprev, u, W, p, f) = integrator
    sqrt3 = sqrt(3one(eltype(W.dW)))
    chi2 = 0.5 * (W.dW + W.dZ / sqrt3) #I_(1,0)/h
    H0[:] = fill(zero(u), stages)

    for i in 1:stages
        A0temp = zero(u)
        B0temp = zero(u)
        for j in 1:(i - 1)
            A0temp = A0temp .+ A₀[j, i] .* integrator.f(H0[j], p, t + c₀[j] * dt)
            B0temp = B0temp .+ B₀[j, i] .* integrator.f.g(H0[j], p, t + c₁[j] * dt) #H0[..,i] argument ignored
        end

        H0[i] = uprev + A0temp * dt + B0temp .* chi2
    end

    atemp = zero(u)
    btemp = zero(u)
    E₂ = zero(u)
    E₁temp = zero(u)

    for i in 1:stages
        ftmp = integrator.f(H0[i], p, t + c₀[i] * dt)
        E₁temp = E₁temp .+ ftmp
        atemp = @.. atemp + α[i] * ftmp

        gtmp = integrator.f.g(H0[i], p, t + c₁[i] * dt) #H0[i] argument ignored
        btemp = @.. btemp + (β₁[i] * W.dW) * gtmp
        E₂ = @.. E₂ + (β₂[i] * chi2) * gtmp
    end

    u = @.. uprev + dt * atemp + btemp + E₂

    if integrator.opts.adaptive
        E₁ = @.. dt * E₁temp

        resids = calculate_residuals(
            E₁, E₂, uprev, u, integrator.opts.abstol,
            integrator.opts.reltol, integrator.opts.delta,
            integrator.opts.internalnorm, t
        )
        integrator.EEst = integrator.opts.internalnorm(resids, t)
    end
    integrator.u = u
end

struct SRIConstantCache{VType1, VType2, MType, uType} <: StochasticDiffEqConstantCache
    c₀::VType1
    c₁::VType1
    A₀::MType
    A₁::MType
    B₀::MType
    B₁::MType
    α::VType2
    β₁::VType2
    β₂::VType2
    β₃::VType2
    β₄::VType2
    stages::Int
    H0::Vector{uType}
    H1::Vector{uType}
    error_terms::Int
end

function SRIConstantCache(tableau, rate_prototype, error_terms)
    (; c₀, c₁, A₀, A₁, B₀, B₁, α, β₁, β₂, β₃, β₄) = tableau
    stages = length(α)
    H0 = Array{typeof(rate_prototype)}(undef, stages)
    H1 = Array{typeof(rate_prototype)}(undef, stages)
    return SRIConstantCache(
        c₀, c₁, A₀', A₁', B₀', B₁', α, β₁, β₂, β₃, β₄, stages, H0, H1, error_terms
    )
end

function alg_cache(
        alg::SRI, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{false}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return SRIConstantCache(alg.tableau, rate_prototype, alg.error_terms)
end

@cache struct SRICache{randType, uType, rateType, tabType} <: StochasticDiffEqMutableCache
    u::uType
    uprev::uType
    H0::Vector{uType}
    H1::Vector{uType}
    A0temp::rateType
    A1temp::rateType
    B0temp::rateType
    B1temp::rateType
    A0temp2::rateType
    A1temp2::rateType
    B0temp2::rateType
    B1temp2::rateType
    atemp::rateType
    btemp::rateType
    E₁::rateType
    E₂::rateType
    E₁temp::rateType
    ftemp::rateType
    gtemp::rateType
    chi1::randType
    chi2::randType
    chi3::randType
    tmp::uType
    tab::tabType
end

function alg_cache(
        alg::SRI, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{true}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    H0 = Vector{typeof(u)}()
    H1 = Vector{typeof(u)}()
    tab = SRIConstantCache(alg.tableau, rate_prototype, alg.error_terms)
    for i in 1:tab.stages
        push!(H0, zero(u))
        push!(H1, zero(u))
    end
    #TODO Reduce memory
    A0temp = zero(rate_prototype)
    A1temp = zero(rate_prototype)
    B0temp = zero(rate_prototype)
    B1temp = zero(rate_prototype)
    A0temp2 = zero(rate_prototype)
    A1temp2 = zero(rate_prototype)
    B0temp2 = zero(rate_prototype)
    B1temp2 = zero(rate_prototype)
    atemp = zero(rate_prototype)
    btemp = zero(rate_prototype)
    E₁ = zero(rate_prototype)
    E₂ = zero(rate_prototype)
    E₁temp = zero(rate_prototype)
    ftemp = zero(rate_prototype)
    gtemp = zero(rate_prototype)

    if ΔW isa Union{SArray, Number}
        chi1 = copy(ΔW)
        chi2 = copy(ΔW)
        chi3 = copy(ΔW)
    else
        chi1 = zero(ΔW)
        chi2 = zero(ΔW)
        chi3 = zero(ΔW)
    end
    tmp = zero(u)
    return SRICache(
        u, uprev, H0, H1, A0temp, A1temp, B0temp,
        B1temp, A0temp2, A1temp2, B0temp2, B1temp2,
        atemp, btemp, E₁, E₂, E₁temp, ftemp, gtemp, chi1, chi2, chi3, tmp, tab
    )
end

struct SRIW1ConstantCache <: StochasticDiffEqConstantCache end
function alg_cache(
        alg::SRIW1, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{false}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return SRIW1ConstantCache()
end

@cache struct SRIW1Cache{randType, uType, rateType} <: StochasticDiffEqMutableCache
    u::uType
    uprev::uType
    chi1::randType
    chi2::randType
    chi3::randType
    fH01o4::rateType
    g₁o2::rateType
    H0::uType
    H11::uType
    H12::uType
    H13::uType
    g₂o3::rateType
    Fg₂o3::rateType
    g₃o3::rateType
    Tg₃o3::rateType
    mg₁::rateType
    E₁::rateType
    E₂::rateType
    fH01::rateType
    fH02::rateType
    g₁::rateType
    g₂::rateType
    g₃::rateType
    g₄::rateType
    tmp::uType
end

function alg_cache(
        alg::SRIW1, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{true}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    if ΔW isa Union{SArray, Number}
        chi1 = copy(ΔW)
        chi2 = copy(ΔW)
        chi3 = copy(ΔW)
    else
        chi1 = zero(ΔW)
        chi2 = zero(ΔW)
        chi3 = zero(ΔW)
    end
    fH01o4 = zero(rate_prototype)
    g₁o2 = zero(rate_prototype)
    H0 = zero(u)
    H11 = zero(u)
    H12 = zero(u)
    H13 = zero(u)
    g₂o3 = zero(rate_prototype)
    Fg₂o3 = zero(rate_prototype)
    g₃o3 = zero(rate_prototype)
    Tg₃o3 = zero(rate_prototype)
    mg₁ = zero(rate_prototype)
    E₁ = zero(rate_prototype)
    E₂ = zero(rate_prototype)
    fH01 = zero(rate_prototype)
    fH02 = zero(rate_prototype)
    g₁ = zero(rate_prototype)
    g₂ = zero(rate_prototype)
    g₃ = zero(rate_prototype)
    g₄ = zero(rate_prototype)
    tmp = zero(u)
    return SRIW1Cache(
        u, uprev, chi1, chi2, chi3, fH01o4, g₁o2, H0, H11, H12, H13, g₂o3,
        Fg₂o3, g₃o3, Tg₃o3, mg₁, E₁, E₂, fH01, fH02, g₁, g₂, g₃, g₄, tmp
    )
end

struct FourStageSRIConstantCache{T, T2} <: StochasticDiffEqConstantCache
    a021::T
    a031::T
    a032::T
    a041::T
    a042::T
    a043::T
    a121::T
    a131::T
    a132::T
    a141::T
    a142::T
    a143::T
    b021::T
    b031::T
    b032::T
    b041::T
    b042::T
    b043::T
    b121::T
    b131::T
    b132::T
    b141::T
    b142::T
    b143::T
    α1::T
    α2::T
    α3::T
    α4::T
    c02::T2
    c03::T2
    c04::T2
    c11::T2
    c12::T2
    c13::T2
    c14::T2
    beta11::T
    beta12::T
    beta13::T
    beta14::T
    beta21::T
    beta22::T
    beta23::T
    beta24::T
    beta31::T
    beta32::T
    beta33::T
    beta34::T
    beta41::T
    beta42::T
    beta43::T
    beta44::T
end

function SRIW2ConstantCache(T::Type, T2::Type)
    a021 = convert(T, 1)
    a031 = convert(T, 1 // 4)
    a032 = convert(T, 1 // 4)
    a041 = convert(T, 0)
    a042 = convert(T, 0)
    a043 = convert(T, 0)
    a121 = convert(T, 1 // 4)
    a131 = convert(T, 1)
    a132 = convert(T, 0)
    a141 = convert(T, 0)
    a142 = convert(T, 0)
    a143 = convert(T, 1 // 4)
    b021 = convert(T, 0)
    b031 = convert(T, 1)
    b032 = convert(T, 1 // 2)
    b041 = convert(T, 0)
    b042 = convert(T, 0)
    b043 = convert(T, 0)
    b121 = convert(T, -1 // 2)
    b131 = convert(T, 1)
    b132 = convert(T, 0)
    b141 = convert(T, 2)
    b142 = convert(T, -1)
    b143 = convert(T, 1 // 2)
    α1 = convert(T, 1 // 6)
    α2 = convert(T, 1 // 6)
    α3 = convert(T, 2 // 3)
    α4 = convert(T, 0)
    c02 = convert(T2, 1)
    c03 = convert(T2, 1 // 2)
    c04 = convert(T2, 0)
    c11 = convert(T2, 0)
    c12 = convert(T2, 1 // 4)
    c13 = convert(T2, 1)
    c14 = convert(T2, 1 // 4)
    beta11 = convert(T, -1)
    beta12 = convert(T, 4 // 3)
    beta13 = convert(T, 2 // 3)
    beta14 = convert(T, 0)
    beta21 = convert(T, 1)
    beta22 = convert(T, -4 // 3)
    beta23 = convert(T, 1 // 3)
    beta24 = convert(T, 0)
    beta31 = convert(T, 2)
    beta32 = convert(T, -4 // 3)
    beta33 = convert(T, -2 // 3)
    beta34 = convert(T, 0)
    beta41 = convert(T, -2)
    beta42 = convert(T, 5 // 3)
    beta43 = convert(T, -2 // 3)
    beta44 = convert(T, 1)
    return FourStageSRIConstantCache(
        a021, a031, a032, a041, a042, a043, a121, a131, a132, a141,
        a142, a143, b021, b031, b032, b041, b042, b043,
        b121, b131, b132, b141, b142, b143, α1, α2,
        α3, α4, c02, c03, c04, c11, c12, c13, c14, beta11,
        beta12, beta13, beta14, beta21, beta22,
        beta23, beta24, beta31, beta32, beta33, beta34, beta41, beta42, beta43, beta44
    )
end

function alg_cache(
        alg::SRIW2, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{false}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return SRIW2ConstantCache(real(uBottomEltypeNoUnits), real(tTypeNoUnits))
end

function SOSRIConstantCache(T::Type, T2::Type)
    a021 = convert(T, -0.04199224421316468)
    a031 = convert(T, 2.842612915017106)
    a032 = convert(T, -2.0527723684000727)
    a041 = convert(T, 4.338237071435815)
    a042 = convert(T, -2.8895936137439793)
    a043 = convert(T, 2.3017575594644466)
    a121 = convert(T, 0.26204282091330466)
    a131 = convert(T, 0.20903646383505375)
    a132 = convert(T, -0.1502377115150361)
    a141 = convert(T, 0.05836595312746999)
    a142 = convert(T, 0.6149440396332373)
    a143 = convert(T, 0.08535117634046772)
    b021 = convert(T, -0.21641093549612528)
    b031 = convert(T, 1.5336352863679572)
    b032 = convert(T, 0.26066223492647056)
    b041 = convert(T, -1.0536037558179159)
    b042 = convert(T, 1.7015284721089472)
    b043 = convert(T, -0.20725685784180017)
    b121 = convert(T, -0.5119011827621657)
    b131 = convert(T, 2.67767339866713)
    b132 = convert(T, -4.9395031322250995)
    b141 = convert(T, 0.15580956238299215)
    b142 = convert(T, 3.2361551006624674)
    b143 = convert(T, -1.4223118283355949)
    α1 = convert(T, 1.140099274172029)
    α2 = convert(T, -0.6401334255743456)
    α3 = convert(T, 0.4736296532772559)
    α4 = convert(T, 0.026404498125060714)
    c02 = convert(T2, -0.04199224421316468)
    c03 = convert(T2, 0.7898405466170333)
    c04 = convert(T2, 3.7504010171562823)
    c11 = convert(T2, 0.0)
    c12 = convert(T2, 0.26204282091330466)
    c13 = convert(T2, 0.05879875232001766)
    c14 = convert(T2, 0.758661169101175)
    beta11 = convert(T, -1.8453464565104432)
    beta12 = convert(T, 2.688764531100726)
    beta13 = convert(T, -0.2523866501071323)
    beta14 = convert(T, 0.40896857551684956)
    beta21 = convert(T, 0.4969658141589478)
    beta22 = convert(T, -0.5771202869753592)
    beta23 = convert(T, -0.12919702470322217)
    beta24 = convert(T, 0.2093514975196336)
    beta31 = convert(T, 2.8453464565104425)
    beta32 = convert(T, -2.688764531100725)
    beta33 = convert(T, 0.2523866501071322)
    beta34 = convert(T, -0.40896857551684945)
    beta41 = convert(T, 0.11522663875443433)
    beta42 = convert(T, -0.57877086147738)
    beta43 = convert(T, 0.2857851028163886)
    beta44 = convert(T, 0.17775911990655704)
    return FourStageSRIConstantCache(
        a021, a031, a032, a041, a042, a043, a121, a131, a132, a141,
        a142, a143, b021, b031, b032, b041, b042, b043,
        b121, b131, b132, b141, b142, b143, α1, α2,
        α3, α4, c02, c03, c04, c11, c12, c13, c14, beta11,
        beta12, beta13, beta14, beta21, beta22,
        beta23, beta24, beta31, beta32, beta33, beta34, beta41, beta42, beta43, beta44
    )
end

function alg_cache(
        alg::SOSRI, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{false}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return SOSRIConstantCache(real(uBottomEltypeNoUnits), real(tTypeNoUnits))
end

function SOSRI2ConstantCache(T::Type, T2::Type)
    a021 = convert(T, 0.13804532298278663)
    a031 = convert(T, 0.5818361298250374)
    a032 = convert(T, 0.4181638701749618)
    a041 = convert(T, 0.4670018408674211)
    a042 = convert(T, 0.8046204792187386)
    a043 = convert(T, -0.27162232008616016)
    a121 = convert(T, 0.45605532163856893)
    a131 = convert(T, 0.7555807846451692)
    a132 = convert(T, 0.24441921535482677)
    a141 = convert(T, 0.6981181143266059)
    a142 = convert(T, 0.3453277086024727)
    a143 = convert(T, -0.04344582292908241)
    b021 = convert(T, 0.08852381537667678)
    b031 = convert(T, 1.0317752458971061)
    b032 = convert(T, 0.4563552922077882)
    b041 = convert(T, 1.73078280444124)
    b042 = convert(T, -0.46089678470929774)
    b043 = convert(T, -0.9637509618944188)
    b121 = convert(T, 0.6753186815412179)
    b131 = convert(T, -0.07452812525785148)
    b132 = convert(T, -0.49783736486149366)
    b141 = convert(T, -0.5591906709928903)
    b142 = convert(T, 0.022696571806569924)
    b143 = convert(T, -0.8984927888368557)
    α1 = convert(T, -0.15036858140642623)
    α2 = convert(T, 0.7545275856696072)
    α3 = convert(T, 0.686995463807979)
    α4 = convert(T, -0.2911544680711602)
    c02 = convert(T2, 0.13804532298278663)
    c03 = convert(T2, 0.9999999999999992)
    c04 = convert(T2, 0.9999999999999994)
    c11 = convert(T2, 0.0)
    c12 = convert(T2, 0.45605532163856893)
    c13 = convert(T2, 0.999999999999996)
    c14 = convert(T2, 0.9999999999999962)
    beta11 = convert(T, -0.45315689727309133)
    beta12 = convert(T, 0.8330937231303951)
    beta13 = convert(T, 0.3792843195533544)
    beta14 = convert(T, 0.24077885458934192)
    beta21 = convert(T, -0.4994383733810986)
    beta22 = convert(T, 0.9181786186154077)
    beta23 = convert(T, -0.25613778661003145)
    beta24 = convert(T, -0.16260245862427797)
    beta31 = convert(T, 1.4531568972730915)
    beta32 = convert(T, -0.8330937231303933)
    beta33 = convert(T, -0.3792843195533583)
    beta34 = convert(T, -0.24077885458934023)
    beta41 = convert(T, -0.4976090683622265)
    beta42 = convert(T, 0.9148155835648892)
    beta43 = convert(T, -1.4102107084476505)
    beta44 = convert(T, 0.9930041932449877)
    return FourStageSRIConstantCache(
        a021, a031, a032, a041, a042, a043, a121, a131, a132, a141,
        a142, a143, b021, b031, b032, b041, b042, b043,
        b121, b131, b132, b141, b142, b143, α1, α2,
        α3, α4, c02, c03, c04, c11, c12, c13, c14, beta11,
        beta12, beta13, beta14, beta21, beta22,
        beta23, beta24, beta31, beta32, beta33, beta34, beta41, beta42, beta43, beta44
    )
end

function alg_cache(
        alg::SOSRI2, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{false}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return SOSRI2ConstantCache(real(uBottomEltypeNoUnits), real(tTypeNoUnits))
end

@cache struct FourStageSRICache{
        uType, randType, tabType, rateNoiseType, rateType, possibleRateType,
    } <:
    StochasticDiffEqMutableCache
    u::uType
    uprev::uType
    chi1::randType
    chi2::randType
    chi3::randType
    tab::tabType
    g1::rateNoiseType
    g2::rateNoiseType
    g3::rateNoiseType
    g4::rateNoiseType
    k1::rateType
    k2::rateType
    k3::rateType
    k4::rateType
    E₁::rateType
    E₂::rateType
    tmp::rateType
    H02::possibleRateType
    H03::possibleRateType
end

function alg_cache(
        alg::SRIW2, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{true}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    if ΔW isa Union{SArray, Number}
        chi1 = copy(ΔW)
        chi2 = copy(ΔW)
        chi3 = copy(ΔW)
    else
        chi1 = zero(ΔW)
        chi2 = zero(ΔW)
        chi3 = zero(ΔW)
    end
    tab = SRIW2ConstantCache(real(uBottomEltypeNoUnits), real(tTypeNoUnits))
    g1 = zero(noise_rate_prototype)
    g2 = zero(noise_rate_prototype)
    g3 = zero(noise_rate_prototype)
    g4 = zero(noise_rate_prototype)
    k1 = zero(rate_prototype)
    k2 = zero(rate_prototype)
    k3 = zero(rate_prototype)
    k4 = zero(rate_prototype)
    E₁ = zero(rate_prototype)
    E₂ = zero(rate_prototype)
    tmp = zero(rate_prototype)
    return FourStageSRICache(
        u, uprev, chi1, chi2, chi3, tab, g1, g2, g3,
        g4, k1, k2, k3, k4, E₁, E₂, tmp, tmp, tmp
    )
end

function alg_cache(
        alg::SOSRI, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{true}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    if ΔW isa Union{SArray, Number}
        chi1 = copy(ΔW)
        chi2 = copy(ΔW)
        chi3 = copy(ΔW)
    else
        chi1 = zero(ΔW)
        chi2 = zero(ΔW)
        chi3 = zero(ΔW)
    end
    tab = SOSRIConstantCache(real(uBottomEltypeNoUnits), real(tTypeNoUnits))
    g1 = zero(noise_rate_prototype)
    g2 = zero(noise_rate_prototype)
    g3 = zero(noise_rate_prototype)
    g4 = zero(noise_rate_prototype)
    k1 = zero(rate_prototype)
    k2 = zero(rate_prototype)
    k3 = zero(rate_prototype)
    k4 = zero(rate_prototype)
    E₁ = zero(rate_prototype)
    E₂ = zero(rate_prototype)
    tmp = zero(rate_prototype)
    return FourStageSRICache(
        u, uprev, chi1, chi2, chi3, tab, g1, g2, g3,
        g4, k1, k2, k3, k4, E₁, E₂, tmp, tmp, tmp
    )
end

function alg_cache(
        alg::SOSRI2, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{true}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    if ΔW isa Union{SArray, Number}
        chi1 = copy(ΔW)
        chi2 = copy(ΔW)
        chi3 = copy(ΔW)
    else
        chi1 = zero(ΔW)
        chi2 = zero(ΔW)
        chi3 = zero(ΔW)
    end
    tab = SOSRI2ConstantCache(real(uBottomEltypeNoUnits), real(tTypeNoUnits))
    g1 = zero(noise_rate_prototype)
    g2 = zero(noise_rate_prototype)
    g3 = zero(noise_rate_prototype)
    g4 = zero(noise_rate_prototype)
    k1 = zero(rate_prototype)
    k2 = zero(rate_prototype)
    k3 = zero(rate_prototype)
    k4 = zero(rate_prototype)
    E₁ = zero(rate_prototype)
    E₂ = zero(rate_prototype)
    tmp = zero(rate_prototype)
    H02 = zero(rate_prototype)
    H03 = zero(rate_prototype)
    return FourStageSRICache(
        u, uprev, chi1, chi2, chi3, tab, g1, g2, g3,
        g4, k1, k2, k3, k4, E₁, E₂, tmp, H02, H03
    )
end

# Rossler

"""
    SRA(;tableau=constructSRA1())

**SRA: Configurable Stochastic Runge-Kutta for Additive Noise (Nonstiff)**

Configurable adaptive strong order 1.5 method for additive noise problems with customizable tableaux.

## Method Properties

  - **Strong Order**: 1.5 (for additive noise)
  - **Weak Order**: Depends on tableau (typically 2.0)
  - **Time stepping**: Adaptive
  - **Noise types**: Additive noise (diagonal, non-diagonal, and scalar)
  - **SDE interpretation**: Both Itô and Stratonovich

## Parameters

  - `tableau`: Tableau specification (default: `constructSRA1()`)

## When to Use

  - When custom tableaux are needed for additive noise problems
  - For research and experimentation with SRA methods
  - When default methods don't provide desired characteristics
  - For benchmarking different SRA variants

## Available Tableaux

  - `constructSRA1()`: Default SRA1 tableau
  - Custom tableaux can be constructed for specialized applications

## References

  - Rößler A., "Runge–Kutta Methods for the Strong Approximation of Solutions of Stochastic Differential Equations", SIAM J. Numer. Anal., 48 (3), pp. 922–952. DOI: 10.1137/09076636X.
"""
struct SRA{TabType} <: StochasticDiffEqAdaptiveAlgorithm
    tableau::TabType
end
SRA(; tableau = constructSRA1()) = SRA(tableau)

"""
    SRI(;tableau=constructSRIW1(), error_terms=4)

**SRI: Configurable Stochastic Runge-Kutta for Itô SDEs (Nonstiff)**

Configurable adaptive strong order 1.5 method for diagonal/scalar Itô SDEs with customizable tableaux.

## Method Properties

  - **Strong Order**: 1.5 (for diagonal/scalar noise)
  - **Weak Order**: Depends on tableau (typically 2.0)
  - **Time stepping**: Adaptive
  - **Noise types**: Diagonal and scalar noise only
  - **SDE interpretation**: Itô

## Parameters

  - `tableau`: Tableau specification (default: `constructSRIW1()`)
  - `error_terms::Int = 4`: Number of error terms for adaptive stepping

## When to Use

  - When custom tableaux are needed for diagonal/scalar problems
  - For research and experimentation with SRI methods
  - When default methods don't provide desired characteristics
  - For benchmarking different SRI variants

## Available Tableaux

  - `constructSRIW1()`: Default SRIW1 tableau
  - Custom tableaux can be constructed for specialized applications

## References

  - Rößler A., "Runge–Kutta Methods for the Strong Approximation of Solutions of Stochastic Differential Equations", SIAM J. Numer. Anal., 48 (3), pp. 922–952. DOI: 10.1137/09076636X.
"""
struct SRI{TabType} <: StochasticDiffEqAdaptiveAlgorithm
    tableau::TabType
    error_terms::Int
end
SRI(; tableau = constructSRIW1(), error_terms = 4) = SRI(tableau, error_terms)

"""
    SRIW1()

**SRIW1: Stochastic Runge-Kutta W1 Method (Nonstiff)**

Adaptive stochastic Runge-Kutta method with strong order 1.5 and weak order 2.0 for diagonal/scalar Itô SDEs.

## Method Properties

  - **Strong Order**: 1.5 (for diagonal/scalar noise)
  - **Weak Order**: 2.0
  - **Time stepping**: Adaptive
  - **Noise types**: Diagonal and scalar noise only
  - **SDE interpretation**: Itô

## When to Use

  - Standard choice for diagonal/scalar Itô SDEs
  - When proven theoretical properties are important
  - Alternative to SOSRI when stability optimization is not needed
  - For problems requiring exactly weak order 2.0

## Algorithm Features

  - Embedded error estimation for adaptive stepping
  - Well-established theoretical foundation
  - Good balance of accuracy and efficiency

## References

  - Rößler A., "Runge–Kutta Methods for the Strong Approximation of Solutions of Stochastic Differential Equations", SIAM J. Numer. Anal., 48 (3), pp. 922–952. DOI: 10.1137/09076636X.
"""
struct SRIW1 <: StochasticDiffEqAdaptiveAlgorithm end

"""
    SRIW2()

**SRIW2: Stochastic Runge-Kutta W2 Method (Nonstiff)**

Adaptive stochastic Runge-Kutta method with strong order 1.5 and weak order 3.0 for diagonal/scalar Itô SDEs.

## Method Properties

  - **Strong Order**: 1.5 (for diagonal/scalar noise)
  - **Weak Order**: 3.0
  - **Time stepping**: Adaptive
  - **Noise types**: Diagonal and scalar noise only
  - **SDE interpretation**: Itô

## When to Use

  - When weak order 3.0 convergence is required
  - For Monte Carlo simulations needing high weak accuracy
  - Problems where weak convergence is more important than strong
  - When computational cost per step is acceptable for higher weak order

## Algorithm Features

  - Highest weak order in the SRI family
  - More expensive per step than SRIW1
  - Excellent for statistical calculations and expectations

## References

  - Rößler A., "Runge–Kutta Methods for the Strong Approximation of Solutions of Stochastic Differential Equations", SIAM J. Numer. Anal., 48 (3), pp. 922–952. DOI: 10.1137/09076636X.
"""
struct SRIW2 <: StochasticDiffEqAdaptiveAlgorithm end
"""
    SOSRI()

**SOSRI: Stability-Optimized SRI Method (Nonstiff) - Recommended**

The Stability-Optimized Stochastic Runge-Kutta method. This is the **recommended method** for general-purpose solving of diagonal/scalar Itô SDEs.

## Method Properties

  - **Strong Order**: 1.5 (for diagonal/scalar noise)
  - **Weak Order**: 2.0
  - **Time stepping**: Adaptive
  - **Noise types**: Diagonal and scalar noise only
  - **SDE interpretation**: Itô
  - **Stability**: Optimized for high tolerances and robust to mild stiffness

## When to Use

  - **Recommended as first choice** for diagonal/scalar Itô SDEs
  - When high accuracy is required (strong order 1.5)
  - For problems with mild stiffness
  - When using high tolerances (method is stable)
  - For most general SDE applications

## Algorithm Description

SOSRI is a stability-optimized version of the SRI methods with specially chosen coefficients to improve stability properties. It provides excellent performance for the most common class of SDE problems.

## Restrictions

  - Only works with diagonal or scalar noise
  - For non-diagonal noise, use other methods like `RKMilCommute` or `LambaEM`

## References

  - Rößler A., "Runge–Kutta Methods for the Strong Approximation of Solutions of Stochastic Differential Equations", SIAM J. Numer. Anal., 48 (3), pp. 922–952
"""
struct SOSRI <: StochasticDiffEqAdaptiveAlgorithm end
"""
    SOSRI2()

**SOSRI2: Alternative Stability-Optimized SRI Method (Nonstiff)**

Alternative stability-optimized adaptive strong order 1.5 method with different stability characteristics than SOSRI.

## Method Properties

  - **Strong Order**: 1.5 (for diagonal/scalar noise)
  - **Weak Order**: 2.0
  - **Time stepping**: Adaptive
  - **Noise types**: Diagonal and scalar noise only
  - **SDE interpretation**: Itô
  - **Stability**: Optimized for high tolerances and robust to stiffness

## When to Use

  - Alternative to SOSRI with different stability properties
  - When SOSRI performance is unsatisfactory
  - For benchmarking stability-optimized methods
  - Problems requiring different stability characteristics

## Algorithm Features

  - Different stability optimization than SOSRI
  - May perform better on certain problem types
  - Maintains high tolerance robustness

## References

  - Stability-optimized SRI methods
"""
struct SOSRI2 <: StochasticDiffEqAdaptiveAlgorithm end

"""
    SRA1()

**SRA1: Stochastic Runge-Kutta A1 Method (Nonstiff)**

Adaptive strong order 1.5 method for additive Itô and Stratonovich SDEs with weak order 2.

## Method Properties

  - **Strong Order**: 1.5 (for additive noise)
  - **Weak Order**: 2.0
  - **Time stepping**: Adaptive
  - **Noise types**: Additive noise (diagonal, non-diagonal, and scalar)
  - **SDE interpretation**: Both Itô and Stratonovich

## When to Use

  - Standard choice for additive noise problems
  - When proven theoretical properties are important
  - Alternative to SOSRA when stability optimization is not needed
  - For both Itô and Stratonovich problems with additive noise

## Additive Noise Structure

Specialized for SDEs of the form:

```math
du = f(u,p,t) dt + σ(p,t) dW
```

where diffusion σ doesn't depend on solution u.

## References

  - Rößler A., "Runge–Kutta Methods for the Strong Approximation of Solutions of Stochastic Differential Equations", SIAM J. Numer. Anal., 48 (3), pp. 922–952. DOI:10.1137/09076636X
"""
struct SRA1 <: StochasticDiffEqAdaptiveAlgorithm end

"""
    SRA2()

**SRA2: Stochastic Runge-Kutta A2 Method (Nonstiff)**

Alternative adaptive strong order 1.5 method for additive noise problems with different coefficients.

## Method Properties

  - **Strong Order**: 1.5 (for additive noise)
  - **Weak Order**: 2.0
  - **Time stepping**: Adaptive
  - **Noise types**: Additive noise (diagonal, non-diagonal, and scalar)
  - **SDE interpretation**: Both Itô and Stratonovich

## When to Use

  - Alternative to SRA1 with different stability/accuracy characteristics
  - When SRA1 performance is unsatisfactory
  - For benchmarking different SRA variants
  - Research and comparison studies

## References

  - Rößler A., "Runge–Kutta Methods for the Strong Approximation of Solutions of Stochastic Differential Equations", SIAM J. Numer. Anal., 48 (3), pp. 922–952. DOI:10.1137/09076636X
"""
struct SRA2 <: StochasticDiffEqAdaptiveAlgorithm end

"""
    SRA3()

**SRA3: Stochastic Runge-Kutta A3 Method (Nonstiff)**

Adaptive strong order 1.5 method for additive noise problems with weak order 3.

## Method Properties

  - **Strong Order**: 1.5 (for additive noise)
  - **Weak Order**: 3.0
  - **Time stepping**: Adaptive
  - **Noise types**: Additive noise (non-diagonal and scalar)
  - **SDE interpretation**: Both Itô and Stratonovich

## When to Use

  - When weak order 3.0 convergence is required for additive noise
  - For Monte Carlo simulations needing highest weak accuracy
  - Problems where weak convergence dominates computational cost
  - When computational cost per step is acceptable for higher weak order

## Restrictions

  - **Does not handle diagonal additive noise** (use SRA1/SRA2 instead)
  - Limited to non-diagonal and scalar additive noise structures

## Algorithm Features

  - Highest weak order in the SRA family
  - More expensive per step than SRA1/SRA2
  - Excellent for statistical calculations requiring high weak accuracy

## References

  - Rößler A., "Runge–Kutta Methods for the Strong Approximation of Solutions of Stochastic Differential Equations", SIAM J. Numer. Anal., 48 (3), pp. 922–952. DOI:10.1137/09076636X
"""
struct SRA3 <: StochasticDiffEqAdaptiveAlgorithm end
"""
    SOSRA()

**SOSRA: Stability-Optimized SRA Method (Nonstiff) - Optimal for Additive Noise**

Stability-optimized adaptive Stochastic Runge-Kutta method for additive noise problems. This is the **optimal choice for additive noise SDEs**.

## Method Properties

  - **Strong Order**: 1.5 (for additive noise)
  - **Weak Order**: 2.0
  - **Time stepping**: Adaptive
  - **Noise types**: Additive noise (diagonal, non-diagonal, and scalar)
  - **SDE interpretation**: Both Itô and Stratonovich
  - **Stability**: Optimized for high tolerances and robust to stiffness

## When to Use

  - **Optimal choice** for additive noise problems: du = f(u,p,t)dt + σ dW
  - When the diffusion term is independent of the solution u
  - For problems requiring high accuracy with additive noise
  - When using high tolerances (method is stable)
  - For both Itô and Stratonovich interpretations

## Algorithm Description

SOSRA is a stability-optimized version of the SRA (Stochastic Runge-Kutta for Additive noise) methods. It exploits the special structure of additive noise to achieve better performance and stability.

## Additive Noise Structure

Specialized for SDEs of the form:

```math
du = f(u,p,t) dt + σ(t) dW
```

where the diffusion σ does not depend on the solution u.

## References

  - Rößler A., "Runge–Kutta Methods for the Strong Approximation of Solutions of Stochastic Differential Equations", SIAM J. Numer. Anal., 48 (3), pp. 922–952
"""
struct SOSRA <: StochasticDiffEqAdaptiveAlgorithm end
"""
    SOSRA2()

**SOSRA2: Stability-Optimized SRA Method Version 2 (Nonstiff)**

Alternative stability-optimized adaptive SRA method for additive noise problems.

## Method Properties

  - **Strong Order**: 1.5 (for additive noise)
  - **Weak Order**: 2.0
  - **Time stepping**: Adaptive
  - **Noise types**: Additive noise (diagonal, non-diagonal, and scalar)
  - **SDE interpretation**: Both Itô and Stratonovich
  - **Stability**: Optimized for high tolerances and robust to stiffness

## When to Use

  - Alternative to SOSRA for additive noise problems
  - Different stability characteristics may be preferred for specific problems
  - When SOSRA performance is unsatisfactory

## References

  - Rößler A., "Runge–Kutta Methods for the Strong Approximation of Solutions of Stochastic Differential Equations", SIAM J. Numer. Anal., 48 (3), pp. 922–952
"""
struct SOSRA2 <: StochasticDiffEqAdaptiveAlgorithm end

module StochasticDiffEqHighOrder

using Reexport
@reexport using StochasticDiffEqCore

import OrdinaryDiffEqCore
import OrdinaryDiffEqCore: perform_step!, initialize!

import StochasticDiffEqCore: alg_cache, alg_order, alg_compatible,
    alg_needs_extra_process, alg_stability_size, delta_default,
    StochasticDiffEqAlgorithm, StochasticDiffEqAdaptiveAlgorithm,
    StochasticDiffEqCache, StochasticDiffEqConstantCache, StochasticDiffEqMutableCache,
    StochasticCompositeAlgorithm,
    get_iterated_I, get_iterated_I!,
    IICommutative, IILevyArea,
    calc_twopoint_random!, calc_twopoint_random,
    @cache

import DiffEqBase: is_diagonal_noise, @..
import DiffEqBase: calculate_residuals, calculate_residuals!
import DiffEqBase: full_cache, rand_cache, ratenoise_cache
import DiffEqBase: Tableau

import MuladdMacro: @muladd

import SciMLBase

using LinearAlgebra
using StaticArrays
using RecursiveArrayTools

include("tableaus.jl")
include("algorithms.jl")
include("alg_utils.jl")

include("caches/rossler_caches.jl")
include("caches/sra_caches.jl")

include("perform_step/sri.jl")
include("perform_step/sra.jl")

export SRI, SRIW1, SRIW2, SOSRI, SOSRI2, SRA, SRA1, SRA2, SRA3, SOSRA, SOSRA2

# Tableau types, constructors and order checkers
export RosslerSRI, RosslerSRA,
    constructSRIW1, constructSRIW2, constructSRIOpt1, constructSRIOpt2,
    constructSRA1, constructSRA2, constructSRA3, constructSOSRA, constructSOSRA2,
    constructSKenCarp, constructExplicitSKenCarp,
    checkSRIOrder, checkSRAOrder

end # module

using SafeTestsets

const TEST_GROUP = get(ENV, "ODEDIFFEQ_TEST_GROUP", "ALL")

if TEST_GROUP == "ALL" || TEST_GROUP == "Core"
    @time @safetestset "Module loads and constructors" begin
        using StochasticDiffEqHighOrder
        using Test

        @test SRI() isa StochasticDiffEqAdaptiveAlgorithm
        @test SRIW1() isa StochasticDiffEqAdaptiveAlgorithm
        @test SRIW2() isa StochasticDiffEqAdaptiveAlgorithm
        @test SOSRI() isa StochasticDiffEqAdaptiveAlgorithm
        @test SOSRI2() isa StochasticDiffEqAdaptiveAlgorithm
        @test SRA() isa StochasticDiffEqAdaptiveAlgorithm
        @test SRA1() isa StochasticDiffEqAdaptiveAlgorithm
        @test SRA2() isa StochasticDiffEqAdaptiveAlgorithm
        @test SRA3() isa StochasticDiffEqAdaptiveAlgorithm
        @test SOSRA() isa StochasticDiffEqAdaptiveAlgorithm
        @test SOSRA2() isa StochasticDiffEqAdaptiveAlgorithm
    end
end

struct SRA1ConstantCache <: StochasticDiffEqConstantCache end
function alg_cache(
        alg::SRA1, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{false}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return SRA1ConstantCache()
end

@cache struct SRA1Cache{randType, rateType, uType, rateNoiseType} <:
    StochasticDiffEqMutableCache
    u::uType
    uprev::uType
    chi2::randType
    tmp1::uType
    E₁::rateType
    E₂::rateType
    gt::rateNoiseType
    k₁::rateType
    k₂::rateType
    gpdt::rateNoiseType
    tmp::uType
end

function alg_cache(
        alg::SRA1, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{true}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    if ΔW isa Union{SArray, Number}
        chi2 = copy(ΔW)
    else
        chi2 = zero(ΔW)
    end
    tmp1 = zero(u)
    E₁ = zero(rate_prototype)
    gt = zero(noise_rate_prototype)
    gpdt = zero(noise_rate_prototype)
    E₂ = zero(rate_prototype)
    k₁ = zero(rate_prototype)
    k₂ = zero(rate_prototype)
    tmp = zero(u)
    return SRA1Cache(u, uprev, chi2, tmp1, E₁, E₂, gt, k₁, k₂, gpdt, tmp)
end

struct SRA2ConstantCache{T, T2} <: StochasticDiffEqConstantCache
    a21::T
    b21::T
    c02::T2
    c11::T2
    c12::T2
    α1::T
    α2::T
    beta12::T
    beta21::T
    beta22::T
end

function SRA2ConstantCache(T::Type, T2::Type)
    a21 = convert(T, 3 // 4)
    b21 = convert(T, 3 // 2)
    c02 = convert(T2, 3 // 4)
    c11 = convert(T2, 1 // 3)
    c12 = convert(T2, 1)
    α1 = convert(T, 1 // 3)
    α2 = convert(T, 2 // 3)
    beta12 = convert(T, 1)
    beta21 = convert(T, 3 // 2)
    beta22 = convert(T, -3 // 2)
    return SRA2ConstantCache(a21, b21, c02, c11, c12, α1, α2, beta12, beta21, beta22)
end

function alg_cache(
        alg::SRA2, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{false}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return SRA2ConstantCache(real(uBottomEltypeNoUnits), real(tTypeNoUnits))
end

@cache struct SRA2Cache{uType, randType, tabType, rateNoiseType, T} <:
    StochasticDiffEqMutableCache
    u::uType
    uprev::uType
    chi2::randType
    tab::tabType
    g1::rateNoiseType
    g2::rateNoiseType
    k1::T
    k2::T
    E₁::T
    E₂::T
    tmp::T
end

function alg_cache(
        alg::SRA2, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{true}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    if ΔW isa Union{SArray, Number}
        chi2 = copy(ΔW)
    else
        chi2 = zero(ΔW)
    end
    tab = SRA2ConstantCache(real(uBottomEltypeNoUnits), real(tTypeNoUnits))
    g1 = zero(noise_rate_prototype)
    g2 = zero(noise_rate_prototype)
    k1 = zero(rate_prototype)
    k2 = zero(rate_prototype)
    E₁ = zero(rate_prototype)
    E₂ = zero(rate_prototype)
    tmp = k1
    return SRA2Cache(u, uprev, chi2, tab, g1, g2, k1, k2, E₁, E₂, tmp)
end

struct ThreeStageSRAConstantCache{T, T2} <: StochasticDiffEqConstantCache
    a21::T
    a31::T
    a32::T
    b21::T
    b31::T
    b32::T
    c02::T2
    c03::T2
    c11::T2
    c12::T2
    c13::T2
    α1::T
    α2::T
    α3::T
    beta11::T
    beta12::T
    beta13::T
    beta21::T
    beta22::T
    beta23::T
end

function SRA3ConstantCache(T::Type, T2::Type)
    a21 = convert(T, 1)
    a31 = convert(T, 1 // 4)
    a32 = convert(T, 1 // 4)
    b21 = convert(T, 0)
    b31 = convert(T, 1)
    b32 = convert(T, 1 // 2)
    c02 = convert(T2, 1)
    c03 = convert(T2, 1 // 2)
    c11 = convert(T2, 1)
    c12 = convert(T2, 0)
    c13 = convert(T2, 0)
    α1 = convert(T, 1 // 6)
    α2 = convert(T, 1 // 6)
    α3 = convert(T, 2 // 3)
    beta11 = convert(T, 1)
    beta12 = convert(T, 0)
    beta13 = convert(T, 0)
    beta21 = convert(T, -1)
    beta22 = convert(T, 1)
    beta23 = convert(T, 0)
    return ThreeStageSRAConstantCache(
        a21, a31, a32, b21, b31, b32, c02, c03, c11, c12, c13,
        α1, α2, α3, beta11, beta12, beta13, beta21, beta22, beta23
    )
end

function SOSRAConstantCache(T::Type, T2::Type)
    α1 = convert(T, 0.2889874966892885)
    α2 = convert(T, 0.6859880440839937)
    α3 = convert(T, 0.025024459226717772)
    c02 = convert(T2, 0.6923962376159507)
    c03 = convert(T2, 1)
    c11 = convert(T2, 0)
    c12 = convert(T2, 0.041248171110700504)
    c13 = convert(T2, 1)
    beta11 = convert(T, -16.792534242221663)
    beta12 = convert(T, 17.514995785380226)
    beta13 = convert(T, 0.27753845684143835)
    beta21 = convert(T, 0.4237535769069274)
    beta22 = convert(T, 0.6010381474428539)
    beta23 = convert(T, -1.0247917243497813)
    a21 = convert(T, 0.6923962376159507)
    a31 = convert(T, -3.1609142252828395)
    a32 = convert(T, 4.1609142252828395)
    b21 = convert(T, 1.3371632704399763)
    b31 = convert(T, 1.442371048468624)
    b32 = convert(T, 1.8632741501139225)
    return ThreeStageSRAConstantCache(
        a21, a31, a32, b21, b31, b32, c02, c03, c11, c12, c13,
        α1, α2, α3, beta11, beta12, beta13, beta21, beta22, beta23
    )
end

function SOSRA2ConstantCache(T::Type, T2::Type)
    α1 = convert(T, 0.4999999999999998)
    α2 = convert(T, -0.9683897375354181)
    α3 = convert(T, 1.4683897375354185)
    c02 = convert(T2, 1)
    c03 = convert(T2, 1)
    c11 = convert(T2, 0)
    c12 = convert(T2, 1)
    c13 = convert(T2, 1)
    beta11 = convert(T, 0)
    beta12 = convert(T, 0.92438032145683)
    beta13 = convert(T, 0.07561967854316998)
    beta21 = convert(T, 1)
    beta22 = convert(T, -0.8169981105823436)
    beta23 = convert(T, -0.18300188941765633)
    a21 = convert(T, 1)
    a31 = convert(T, 0.9511849235504364)
    a32 = convert(T, 0.04881507644956362)
    b21 = convert(T, 0.7686101171003622)
    b31 = convert(T, 0.43886792994934987)
    b32 = convert(T, 0.7490415909204886)
    return ThreeStageSRAConstantCache(
        a21, a31, a32, b21, b31, b32, c02, c03, c11, c12, c13,
        α1, α2, α3, beta11, beta12, beta13, beta21, beta22, beta23
    )
end

function alg_cache(
        alg::SRA3, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype,
        ::Type{uEltypeNoUnits}, ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev,
        f, t, dt,
        ::Type{Val{false}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return SRA3ConstantCache(real(uBottomEltypeNoUnits), real(tTypeNoUnits))
end

function alg_cache(
        alg::SOSRA, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype,
        ::Type{uEltypeNoUnits}, ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev,
        f, t, dt,
        ::Type{Val{false}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return SOSRAConstantCache(real(uBottomEltypeNoUnits), real(tTypeNoUnits))
end

function alg_cache(
        alg::SOSRA2, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype,
        ::Type{uEltypeNoUnits}, ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev,
        f, t, dt,
        ::Type{Val{false}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return SOSRA2ConstantCache(real(uBottomEltypeNoUnits), real(tTypeNoUnits))
end

@cache struct ThreeStageSRACache{uType, randType, tabType, rateNoiseType, rateType, GT} <:
    StochasticDiffEqMutableCache
    u::uType
    uprev::uType
    chi2::randType
    tab::tabType
    g1::rateNoiseType
    g2::rateNoiseType
    g3::rateNoiseType
    k1::rateType
    k2::rateType
    k3::rateType
    E₁::rateType
    E₂::rateType
    tmp::rateType
    gtmp::GT
end

function alg_cache(
        alg::SRA3, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{true}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    if ΔW isa Union{SArray, Number}
        chi2 = copy(ΔW)
    else
        chi2 = zero(ΔW)
    end
    tab = SRA3ConstantCache(real(uBottomEltypeNoUnits), real(tTypeNoUnits))
    g1 = zero(noise_rate_prototype)
    g2 = zero(noise_rate_prototype)
    g3 = zero(noise_rate_prototype)
    k1 = zero(rate_prototype)
    k2 = zero(rate_prototype)
    k3 = zero(rate_prototype)
    E₁ = zero(rate_prototype)
    E₂ = zero(rate_prototype)
    tmp = k1
    if typeof(noise_rate_prototype) == typeof(rate_prototype)
        gtmp = nothing
    else
        gtmp = zero(noise_rate_prototype)
    end
    return ThreeStageSRACache(u, uprev, chi2, tab, g1, g2, g3, k1, k2, k3, E₁, E₂, tmp, gtmp)
end

function alg_cache(
        alg::SOSRA, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{true}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    if ΔW isa Union{SArray, Number}
        chi2 = copy(ΔW)
    else
        chi2 = zero(ΔW)
    end
    tab = SOSRAConstantCache(real(uBottomEltypeNoUnits), real(tTypeNoUnits))
    g1 = zero(noise_rate_prototype)
    g2 = zero(noise_rate_prototype)
    g3 = zero(noise_rate_prototype)
    k1 = zero(rate_prototype)
    k2 = zero(rate_prototype)
    k3 = zero(rate_prototype)
    E₁ = zero(rate_prototype)
    E₂ = zero(rate_prototype)
    tmp = k1
    if typeof(noise_rate_prototype) == typeof(rate_prototype)
        gtmp = nothing
    else
        gtmp = zero(noise_rate_prototype)
    end
    return ThreeStageSRACache(u, uprev, chi2, tab, g1, g2, g3, k1, k2, k3, E₁, E₂, tmp, gtmp)
end

function alg_cache(
        alg::SOSRA2, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{true}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    if ΔW isa Union{SArray, Number}
        chi2 = copy(ΔW)
    else
        chi2 = zero(ΔW)
    end
    tab = SOSRA2ConstantCache(real(uBottomEltypeNoUnits), real(tTypeNoUnits))
    g1 = zero(noise_rate_prototype)
    g2 = zero(noise_rate_prototype)
    g3 = zero(noise_rate_prototype)
    k1 = zero(rate_prototype)
    k2 = zero(rate_prototype)
    k3 = zero(rate_prototype)
    E₁ = zero(rate_prototype)
    E₂ = zero(rate_prototype)
    tmp = k1
    if typeof(noise_rate_prototype) == typeof(rate_prototype)
        gtmp = nothing
    else
        gtmp = zero(noise_rate_prototype)
    end
    return ThreeStageSRACache(u, uprev, chi2, tab, g1, g2, g3, k1, k2, k3, E₁, E₂, tmp, gtmp)
end

struct SRAConstantCache{VType1, VType2, MType, uType} <: StochasticDiffEqConstantCache
    c₀::VType1
    c₁::VType1
    A₀::MType
    B₀::MType
    α::VType2
    β₁::VType2
    β₂::VType2
    stages::Int
    H0::Vector{uType}
end

function SRAConstantCache(tableau, rate_prototype)
    (; c₀, c₁, A₀, B₀, α, β₁, β₂) = tableau
    stages = length(α)
    H0 = Vector{typeof(rate_prototype)}(undef, stages)
    return SRAConstantCache(c₀, c₁, A₀', B₀', α, β₁, β₂, stages, H0)
end

function alg_cache(
        alg::SRA, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{false}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return SRAConstantCache(alg.tableau, rate_prototype)
end

@cache struct SRACache{uType, rateType, tabType, randType, rateNoiseType} <:
    StochasticDiffEqMutableCache
    u::uType
    uprev::uType
    H0::Vector{uType}
    A0temp::rateType
    B0temp::rateType
    ftmp::rateType
    gtmp::rateNoiseType
    chi2::randType
    atemp::rateType
    btemp::rateType
    E₁::rateType
    E₁temp::rateType
    E₂::rateType
    tmp::uType
    tab::tabType
end

u_cache(c::SRACache) = ()
function du_cache(c::SRACache)
    return (
        c.A0temp, c.B0temp, c.ftmp, c.gtmp, c.chi2, c.chi2, c.atemp,
        c.btemp, c.E₁, c.E₁temp, c.E₂,
    )
end
user_cache(c::SRACache) = (c.u, c.uprev, c.tmp, c.H0...)

function alg_cache(
        alg::SRA, prob, u, ΔW, ΔZ, p, rate_prototype,
        noise_rate_prototype, jump_rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, f, t, dt,
        ::Type{Val{true}}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    H0 = Vector{typeof(u)}()
    tab = SRAConstantCache(alg.tableau, rate_prototype)
    for i in 1:tab.stages
        push!(H0, zero(u))
    end
    A0temp = zero(rate_prototype)
    B0temp = zero(rate_prototype)
    ftmp = zero(rate_prototype)
    gtmp = zero(noise_rate_prototype)
    if ΔW isa Union{SArray, Number}
        chi2 = copy(ΔW)
    else
        chi2 = zero(ΔW)
    end
    atemp = zero(rate_prototype)
    btemp = zero(rate_prototype)
    E₂ = zero(rate_prototype)
    E₁temp = zero(rate_prototype)
    E₁ = zero(rate_prototype)
    tmp = zero(u)
    return SRACache(
        u, uprev, H0, A0temp, B0temp, ftmp, gtmp,
        chi2, atemp, btemp, E₁, E₁temp, E₂, tmp, tab
    )
end
